%bcond_with shared_readline

Name: bash
Version: 5.2
Release: 1
License: GPL-3.0-or-later
Summary: GNU Bourne Again Shell
Url: http://www.gnu.org/software/bash/bash.html

%if %{with shared_readline}
BuildRequires: readline-devel >= 7.0
%else
BuildRequires: ncurses-devel
%endif
BuildRequires: libiconv-devel
BuildRequires: sqlcli-devel

Source0: https://ftp.gnu.org/gnu/bash/bash-%{version}.tar.gz

Source1: getjobid.def
Source2: liblist.def
Source3: cl.def

Patch1: bash52-001
Patch2: bash52-002
Patch3: bash52-003
Patch4: bash52-004
Patch5: bash52-005
Patch6: bash52-006
Patch7: bash52-007
Patch8: bash52-008
Patch9: bash52-009
Patch10: bash52-010
Patch11: bash52-011
Patch12: bash52-012
Patch13: bash52-013
Patch14: bash52-014
Patch15: bash52-015

Patch100: bash-pase-customization.patch
Patch103: bash-ibmi-builtins.patch

%description
Bash is the GNU Project's shell. Bash is the Bourne Again SHell. Bash is an
sh-compatible shell that incorporates useful features from the Korn shell (ksh)
and C shell (csh). It is intended to conform to the IEEE POSIX P1003.2/ISO
9945.2 Shell and Tools standard. It offers functional improvements over sh for
both programming and interactive use. In addition, most sh scripts can be run by
Bash without modification.

%prep
%setup -q

%patch1
%patch2
%patch3
%patch4
%patch5
%patch6
%patch7
%patch8
%patch9
%patch10
%patch11
%patch12
%patch13
%patch14
%patch15

%patch100 -p1
%patch103 -p1

sed -i 's|/etc/inputrc|%{_sysconfdir}/inputrc|g' lib/readline/rlconf.h

cp %SOURCE1 %SOURCE2 %SOURCE3 builtins

%build

%configure \
  ac_cv_func_faccessat=no \
  ac_cv_func_fchmodat=no \
  ac_cv_func_fchownat=no \
  ac_cv_func_fstatat=no \
  ac_cv_func_futimesat=no \
  ac_cv_func_linkat=no \
  ac_cv_func_lstat=yes \
  ac_cv_func_mkdirat=no \
  ac_cv_func_mkfifoat=no \
  ac_cv_func_mknodat=no \
  ac_cv_func_openat=no \
  ac_cv_func_readlinkat=no \
  ac_cv_func_renameat=no \
  ac_cv_func_symlinkat=no \
  ac_cv_func_unlinkat=no \
  ac_cv_func_utimensat=no \
  LDFLAGS="-Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib" \
%if ! %{with shared_readline}
  CFLAGS="$CFLAGS -I%{_includedir}/libiconv -I%{_includedir}/ncurses -I%{_includedir}/cli" \
  bash_cv_termcap_lib=libncurses \
%else
  CFLAGS="$CFLAGS -I%{_includedir}/libiconv -I%{_includedir}/cli" \
  --with-installed-readline \
%endif
  --without-bash-malloc \
  --disable-nls

%make_build

%install

%make_install

mkdir -p %{buildroot}/bin
ln -s %{_bindir}/bash %{buildroot}/bin/bash

%files
%defattr(-, qsys, *none)

/bin/bash
%{_bindir}/bash
%{_bindir}/bashbug
%{_infodir}/bash.info*
%{_docdir}/bash
%{_mandir}/man1/bash.1*
%{_mandir}/man1/bashbug.1*

%changelog
* Wed Sep 13 2023 Kevin Adler <kadler@us.ibm.com> - 5.2
- Update to 5.2
- Add fetch-patches.sh to download upstream patches
- Merge PASE customization patches in to a single patch file
- Drop patch setting the PASE CCSID since it caused too many problems and is
  mostly unneeded since IBM i 7.4 is UTF-8 by default.

* Thu May 20 2021 Kevin Adler <kadler@us.ibm.com> - 5.1
- Update to 5.1

* Mon Mar 8 2021 Abdirahim Musse <abdirahim.musse@ibm.com> - 4.4
- Set PASE CCSID when locale is changed

* Mon Feb 22 2021 Abdirahim Musse <abdirahim.musse@ibm.com> - 4.4
- Look for global inputrc in /QOpenSyst/etc instead of /etc for consistency

* Wed Feb 10 2021 Kevin Adler <kadler@us.ibm.com> - 4.4
- Fix -K option of cl builtin & adjust its help text to match the `system` docs

* Wed Dec 23 2020 Kevin Adler <kadler@us.ibm.com> - 4.4
- Ensure liblist library type has proper CCSID set

* Wed Dec 23 2020 Kevin Adler <kadler@us.ibm.com> - 4.4
- Enable -S option in cl builtin

* Mon Dec 14 2020 Kevin Adler <kadler@us.ibm.com> - 4.4
- Add liblist, cl, and getjobid builtins

* Wed May 27 2020 Kevin Adler <kadler@us.ibm.com> - 4.4
- Use generic paths for man and info pages to allow for compression

* Thu Nov 21 2019 Kevin Adler <kadler@us.ibm.com> - 4.4
- Disable half-implemented *at APIs, fixing IBM i 7.2 build

* Wed Nov 20 2019 Kevin Adler <kadler@us.ibm.com> - 4.4
- Use SPDX license identifier

* Fri Jan 18 2019 - Kevin Adler <kadler@us.ibm.com>
- Add patches up to 4.4.23

* Fri Sep 07 2018 - Kevin Adler <kadler@us.ibm.com>
- Build with ncurses

* Sat Mar 03 2018 - Kevin Adler <kadler@us.ibm.com>
- Major spec cleanup

* Wed Dec 20 2017 - Kevin Adler <kadler@us.ibm.com>
- Add libiconv build requirement

* Tue Nov 21 2017 - Kevin Adler <kadler@us.ibm.com>
- Fix shebang in bashbug
- Remove unneeded Provides/Requires lines
